const char *FtsDatabaseSchema =
        "CREATE TABLE IF NOT EXISTS document_index ("
        "   id TEXT NOT NULL,"
        "   index_id TEXT NOT NULL,"
        "   size INTEGER NOT NULL,"
        "   path TEXT NOT NULL,"
        "   path_depth INT NOT NULL,"
        "   mtime INTEGER NOT NULL,"
        "   mime TEXT NOT NULL,"
        "   json_data TEXT NOT NULL,"
        "   PRIMARY KEY (id, index_id)"
        ");"
        ""
        "CREATE VIEW IF NOT EXISTS document_view (rowid, name, content)"
        " AS"
        " SELECT rowid,"
        "  json_data->>'name',"
        "  json_data->>'content'"
        " FROM document_index;"
        ""
        "CREATE INDEX IF NOT EXISTS document_index_size_idx ON document_index (size);"
        "CREATE INDEX IF NOT EXISTS document_index_mtime_idx ON document_index (mtime);"
        "CREATE INDEX IF NOT EXISTS document_index_mime_idx ON document_index (mime);"
        "CREATE INDEX IF NOT EXISTS document_index_path_idx ON document_index (path);"
        "CREATE INDEX IF NOT EXISTS document_index_path_depth_idx ON document_index (path_depth);"
        ""
        "CREATE VIRTUAL TABLE IF NOT EXISTS search USING fts5 ("
        "    name,"
        "    content,"
        "    content='document_view'"
        ");"
        ""
        "CREATE TRIGGER IF NOT EXISTS on_insert AFTER INSERT ON document_index BEGIN"
        "    INSERT INTO search(rowid, name, content) VALUES (new.rowid, new.json_data->>'name', new.json_data->>'content');"
        "END;"
        "CREATE TRIGGER IF NOT EXISTS on_delete AFTER DELETE ON document_index BEGIN"
        "    INSERT INTO search(search, name, content) VALUES('delete', old.json_data->>'name', old.json_data->>'content');"
        "END;"
        "CREATE TRIGGER IF NOT EXISTS on_update AFTER UPDATE ON document_index BEGIN"
        "    INSERT INTO search(search, rowid, name, content) VALUES('delete', old.rowid, old.json_data->>'name', old.json_data->>'content');"
        "    INSERT INTO search(rowid, name, content) VALUES (new.rowid, new.json_data->>'name', new.json_data->>'content');"
        "END;";

const char *IpcDatabaseSchema =
        "CREATE TABLE parse_job ("
        "   id INTEGER PRIMARY KEY,"
        "   filepath TEXT NOT NULL,"
        "   mtime INTEGER NOT NULL,"
        "   st_size INTEGER NOT NULL"
        ");"
        ""
        "CREATE TABLE index_job ("
        "   id INTEGER PRIMARY KEY,"
        "   doc_id TEXT NOT NULL CHECK ( length(doc_id) = 32 ),"
        "   type INTEGER NOT NULL,"
        "   line TEXT"
        ");";

const char *IndexDatabaseSchema =
        "CREATE TABLE thumbnail ("
        "   id TEXT NOT NULL CHECK ( length(id) = 32 ),"
        "   num INTEGER NOT NULL,"
        "   data BLOB NOT NULL,"
        "   PRIMARY KEY(id, num)"
        ") WITHOUT ROWID;"
        ""
        "CREATE TABLE document ("
        "   id TEXT PRIMARY KEY CHECK ( length(id) = 32 ),"
        "   marked INTEGER NOT NULL DEFAULT (1),"
        "   mtime INTEGER NOT NULL,"
        "   size INTEGER NOT NULL,"
        "   json_data TEXT NOT NULL CHECK ( json_valid(json_data) )"
        ") WITHOUT ROWID;"
        ""
        "CREATE TABLE delete_list ("
        "   id TEXT PRIMARY KEY CHECK ( length(id) = 32 )"
        ") WITHOUT ROWID;"
        ""
        "CREATE TABLE tag ("
        "   id TEXT NOT NULL,"
        "   tag TEXT NOT NULL"
        ");"
        ""
        "CREATE TABLE document_sidecar ("
        "   id TEXT PRIMARY KEY NOT NULL,"
        "   json_data TEXT NOT NULL"
        ") WITHOUT ROWID;"
        ""
        "CREATE TABLE descriptor ("
        "   id TEXT NOT NULL,"
        "   version_major INTEGER NOT NULL,"
        "   version_minor INTEGER NOT NULL,"
        "   version_patch INTEGER NOT NULL,"
        "   root TEXT NOT NULL,"
        "   name TEXT NOT NULL,"
        "   rewrite_url TEXT,"
        "   timestamp INTEGER NOT NULL"
        ");"
        ""
        "CREATE TABLE stats_treemap ("
        "   path TEXT NOT NULL,"
        "   size INTEGER NOT NULL"
        ");"
        ""
        "CREATE TABLE stats_size_agg ("
        "   bucket INTEGER NOT NULL,"
        "   count INTEGER NOT NULL"
        ");"
        ""
        "CREATE TABLE stats_date_agg ("
        "   bucket INTEGER NOT NULL,"
        "   count INTEGER NOT NULL"
        ");"
        ""
        "CREATE TABLE stats_mime_agg ("
        "   mime TEXT NOT NULL,"
        "   size INTEGER NOT NULL,"
        "   count INTEGER NOT NULL"
        ");";

